import TypeGuard from "./type-guard.js";
export function getThisArg(expression, scope) {
    if (TypeGuard.isMemberExpression(expression)) {
        const key = TypeGuard.isIdentifier(expression.property) && !expression.computed ? expression.property.name : `${expression.property.evaluate(scope)}`;
        const thisArg = expression.object.evaluate(scope);
        return [thisArg, thisArg[key]];
    }
    return [undefined, expression.evaluate(scope)];
}
