import NodeType from "../node-type.js";
import TypeGuard from "../type-guard.js";
export default class AssignmentProperty {
    _computed;
    get computed() {
        return this._computed;
    }
    /* c8 ignore next 4 */
    set computed(value) {
        this._computed = value;
    }
    _key;
    get key() {
        return this._key;
    }
    /* c8 ignore next 4 */
    set key(value) {
        this._key = value;
    }
    _shorthand;
    get shorthand() {
        return this._shorthand;
    }
    /* c8 ignore next 4 */
    set shorthand(value) {
        this._shorthand = value;
    }
    _value;
    get value() {
        return this._value;
    }
    /* c8 ignore next 4 */
    set value(value) {
        this._value = value;
    }
    get type() {
        return NodeType.AssignmentProperty;
    }
    constructor(key, value, computed = false, shorthand = false) {
        this._key = key;
        this._value = value;
        this._computed = computed;
        this._shorthand = shorthand;
    }
    clone() {
        return new AssignmentProperty(this.key.clone(), this.value.clone(), this.computed, this.shorthand);
    }
    toString() {
        if (this.shorthand) {
            return this.value.toString();
        }
        if (TypeGuard.isIdentifier(this.key) || TypeGuard.isLiteral(this.key) && typeof this.key.value == "number") {
            return `${this.computed ? `[${this.key}]` : this.key}: ${this.value}`;
        }
        return `${this.computed ? `[${this.key}]` : this.key}: ${this.value}`;
    }
}
