import type IExpression from "../interfaces/expression.js";
import type INode from "../interfaces/node.js";
import NodeType from "../node-type.js";
export default class Property implements INode {
    private _computed;
    get computed(): boolean;
    set computed(value: boolean);
    private _key;
    get key(): IExpression;
    set key(value: IExpression);
    private _shorthand;
    get shorthand(): boolean;
    set shorthand(value: boolean);
    private _value;
    get value(): IExpression;
    set value(value: IExpression);
    get type(): NodeType;
    constructor(key: IExpression, value: IExpression, computed?: boolean, shorthand?: boolean);
    clone(): Property;
    toString(): string;
}
