import AssignmentProperty from "./elements/assignment-property.js";
import Property from "./elements/property.js";
import SpreadElement from "./elements/spread-element.js";
import ExpressionVisitor from "./expression-visitor.js";
import ArrayExpression from "./expressions/array-expression.js";
import ArrowFunctionExpression from "./expressions/arrow-function-expression.js";
import AssignmentExpression from "./expressions/assignment-expression.js";
import BinaryExpression from "./expressions/binary-expression.js";
import CallExpression from "./expressions/call-expression.js";
import ChainExpression from "./expressions/chain-expression.js";
import ConditionalExpression from "./expressions/conditional-expression.js";
import LogicalExpression from "./expressions/logical-expression.js";
import MemberExpression from "./expressions/member-expression.js";
import NewExpression from "./expressions/new-expression.js";
import ObjectExpression from "./expressions/object-expression.js";
import ParenthesizedExpression from "./expressions/parenthesized-expression.js";
import SequenceExpression from "./expressions/sequence-expression.js";
import TaggedTemplateExpression from "./expressions/tagged-template-expression.js";
import TemplateLiteral from "./expressions/template-literal.js";
import UnaryExpression from "./expressions/unary-expression.js";
import UpdateExpression from "./expressions/update-expression.js";
import type INode from "./interfaces/node.js";
import ArrayPattern from "./patterns/array-pattern.js";
import AssignmentPattern from "./patterns/assignment-pattern.js";
import ObjectPattern from "./patterns/object-pattern.js";
import RestElement from "./patterns/rest-element.js";
export default abstract class ExpressionRewriterVisitor extends ExpressionVisitor {
    protected visitArrayExpression(node: ArrayExpression): INode;
    protected visitArrayPattern(node: ArrayPattern): INode;
    protected visitArrowFunctionExpression(node: ArrowFunctionExpression): INode;
    protected visitAssignmentExpression(node: AssignmentExpression): INode;
    protected visitAssignmentPattern(node: AssignmentPattern): INode;
    protected visitAssignmentProperty(node: AssignmentProperty): INode;
    protected visitBinaryExpression(node: BinaryExpression): INode;
    protected visitCallExpression(node: CallExpression): INode;
    protected visitChainExpression(node: ChainExpression): INode;
    protected visitConditionalExpression(node: ConditionalExpression): INode;
    protected visitLogicalExpression(node: LogicalExpression): INode;
    protected visitMemberExpression(node: MemberExpression): INode;
    protected visitNewExpression(node: NewExpression): INode;
    protected visitObjectExpression(node: ObjectExpression): INode;
    protected visitObjectPattern(node: ObjectPattern): INode;
    protected visitParenthesizedExpression(node: ParenthesizedExpression): INode;
    protected visitProperty(node: Property): INode;
    protected visitRestElement(node: RestElement): INode;
    protected visitSequenceExpression(node: SequenceExpression): INode;
    protected visitSpreadExpression(node: SpreadElement): INode;
    protected visitTaggedTemplateExpression(node: TaggedTemplateExpression): INode;
    protected visitTemplateLiteral(node: TemplateLiteral): INode;
    protected visitUnaryExpression(node: UnaryExpression): INode;
    protected visitUpdateExpression(node: UpdateExpression): INode;
}
