import type IExpression from "../interfaces/expression.js";
import NodeType from "../node-type.js";
import type { AssignmentOperator } from "../types/operators.js";
import type Identifier from "./identifier.js";
import type MemberExpression from "./member-expression.js";
export default class AssignmentExpression implements IExpression {
    private readonly operation;
    private _left;
    get left(): Identifier | MemberExpression;
    set left(value: Identifier | MemberExpression);
    private _operator;
    get operator(): AssignmentOperator;
    set operator(value: AssignmentOperator);
    private _right;
    get right(): IExpression;
    set right(value: IExpression);
    get type(): NodeType;
    constructor(left: Identifier | MemberExpression, right: IExpression, operator: AssignmentOperator);
    clone(): AssignmentExpression;
    evaluate(scope: object): unknown;
    toString(): string;
}
