import type IExpression from "../interfaces/expression.js";
import NodeType from "../node-type.js";
import type { BinaryOperator } from "../types/operators.js";
export default class BinaryExpression implements IExpression {
    private readonly operation;
    private _left;
    get left(): IExpression;
    set left(value: IExpression);
    private _operator;
    get operator(): BinaryOperator;
    set operator(value: BinaryOperator);
    private _right;
    get right(): IExpression;
    set right(value: IExpression);
    get type(): NodeType;
    constructor(left: IExpression, right: IExpression, operator: BinaryOperator);
    clone(): BinaryExpression;
    evaluate(scope: object): unknown;
    toString(): string;
}
