import type SpreadElement from "../elements/spread-element.js";
import type IChainElement from "../interfaces/chain-element.js";
import type IExpression from "../interfaces/expression.js";
import NodeType from "../node-type.js";
export default class CallExpression implements IExpression, IChainElement {
    private _arguments;
    get arguments(): (IExpression | SpreadElement)[];
    set arguments(value: (IExpression | SpreadElement)[]);
    private _callee;
    get callee(): IExpression;
    set callee(value: IExpression);
    private _optional;
    get optional(): boolean;
    set optional(value: boolean);
    get type(): NodeType;
    constructor(callee: IExpression, $arguments?: (IExpression | SpreadElement)[], optional?: boolean);
    clone(): CallExpression;
    evaluate(scope: object): unknown;
    toString(): string;
}
