import NodeType from "../node-type.js";
export default class ConditionalExpression {
    _alternate;
    get alternate() {
        return this._alternate;
    }
    /* c8 ignore next 4 */
    set alternate(value) {
        this._alternate = value;
    }
    _consequent;
    get consequent() {
        return this._consequent;
    }
    /* c8 ignore next 4 */
    set consequent(value) {
        this._consequent = value;
    }
    _test;
    get test() {
        return this._test;
    }
    /* c8 ignore next 4 */
    set test(value) {
        this._test = value;
    }
    get type() {
        return NodeType.ConditionalExpression;
    }
    constructor(test, alternate, consequent) {
        this._test = test;
        this._consequent = consequent;
        this._alternate = alternate;
    }
    clone() {
        return new ConditionalExpression(this.test.clone(), this.alternate.clone(), this.consequent.clone());
    }
    evaluate(scope) {
        return this.test.evaluate(scope) ? this.alternate.evaluate(scope) : this.consequent.evaluate(scope);
    }
    toString() {
        return `${this.test} ? ${this.alternate} : ${this.consequent}`;
    }
}
