import { format } from "@surface/core";
import Messages from "../messages.js";
import NodeType from "../node-type.js";
import { PATTERN } from "../symbols.js";
export default class Identifier {
    _name;
    [PATTERN] = undefined;
    get name() {
        return this._name;
    }
    /* c8 ignore next 4 */
    set name(value) {
        this._name = value;
    }
    get type() {
        return NodeType.Identifier;
    }
    constructor(name) {
        this._name = name;
    }
    clone() {
        return new Identifier(this.name);
    }
    evaluate(scope, value) {
        if (arguments.length == 2) {
            return { [this.name]: value };
        }
        if (this.name == "undefined") {
            return undefined;
        }
        if (!(this.name in scope)) {
            throw new ReferenceError(format(Messages.identifierIsNotDefined, { identifier: this.name }));
        }
        return scope[this.name];
    }
    toString() {
        return this.name;
    }
}
