import type IExpression from "../interfaces/expression.js";
import NodeType from "../node-type.js";
import type { LogicalOperator } from "../types/operators.js";
export default class LogicalExpression implements IExpression {
    private readonly operation;
    private _left;
    get left(): IExpression;
    set left(value: IExpression);
    private _operator;
    get operator(): LogicalOperator;
    set operator(value: LogicalOperator);
    private _right;
    get right(): IExpression;
    set right(value: IExpression);
    get type(): NodeType;
    constructor(left: IExpression, right: IExpression, operator: LogicalOperator);
    clone(): LogicalExpression;
    evaluate(scope: object): unknown;
    toString(): string;
}
