import NodeType from "../node-type.js";
const binaryFunctions = {
    "&&": (left, right, scope) => left.evaluate(scope) && right.evaluate(scope),
    "??": (left, right, scope) => left.evaluate(scope) ?? right.evaluate(scope),
    "||": (left, right, scope) => left.evaluate(scope) || right.evaluate(scope),
};
export default class LogicalExpression {
    operation;
    _left;
    get left() {
        return this._left;
    }
    /* c8 ignore next 4 */
    set left(value) {
        this._left = value;
    }
    _operator;
    get operator() {
        return this._operator;
    }
    /* c8 ignore next 4 */
    set operator(value) {
        this._operator = value;
    }
    _right;
    get right() {
        return this._right;
    }
    /* c8 ignore next 4 */
    set right(value) {
        this._right = value;
    }
    get type() {
        return NodeType.LogicalExpression;
    }
    constructor(left, right, operator) {
        this._left = left;
        this._operator = operator;
        this._right = right;
        this.operation = binaryFunctions[this.operator];
    }
    clone() {
        return new LogicalExpression(this.left.clone(), this.right.clone(), this.operator);
    }
    evaluate(scope) {
        return this.operation(this.left, this.right, scope);
    }
    toString() {
        return `${this.left} ${this.operator} ${this.right}`;
    }
}
