import type IChainElement from "../interfaces/chain-element.js";
import type IExpression from "../interfaces/expression.js";
import NodeType from "../node-type.js";
export default class MemberExpression implements IExpression, IChainElement {
    private _computed;
    get computed(): boolean;
    set computed(value: boolean);
    private _property;
    get property(): IExpression;
    set property(value: IExpression);
    private _object;
    get object(): IExpression;
    set object(value: IExpression);
    private _optional;
    get optional(): boolean;
    set optional(value: boolean);
    get type(): NodeType;
    constructor(object: IExpression, property: IExpression, computed: boolean, optional: boolean);
    clone(): MemberExpression;
    evaluate(scope: object): unknown;
    toString(): string;
}
