import NodeType from "../node-type.js";
export default class SequenceExpression {
    _expressions;
    get expressions() {
        return this._expressions;
    }
    /* c8 ignore next 4 */
    set expressions(value) {
        this._expressions = value;
    }
    get type() {
        return NodeType.SequenceExpression;
    }
    constructor(expressions) {
        this._expressions = expressions;
    }
    clone() {
        return new SequenceExpression(this.expressions.map(x => x.clone()));
    }
    evaluate(scope) {
        let value;
        for (const expression of this.expressions) {
            value = expression.evaluate(scope);
        }
        return value;
    }
    toString() {
        return `(${this.expressions.map(x => x.toString()).join(", ")})`;
    }
}
