import NodeType from "../node-type.js";
export default class TemplateLiteral {
    _expressions;
    _quasis;
    get expressions() {
        return this._expressions;
    }
    /* c8 ignore next 4 */
    set expressions(value) {
        this._expressions = value;
    }
    get quasis() {
        return this._quasis;
    }
    /* c8 ignore next 4 */
    set quasis(value) {
        this._quasis = value;
    }
    get type() {
        return NodeType.TemplateLiteral;
    }
    constructor(quasis, expressions) {
        this._expressions = expressions;
        this._quasis = quasis;
    }
    clone() {
        return new TemplateLiteral(this.quasis.map(x => x.clone()), this.expressions.map(x => x.clone()));
    }
    evaluate(scope) {
        let result = "";
        for (let i = 0; i < this.expressions.length; i++) {
            result += `${this.quasis[i].cooked}${this.expressions[i].evaluate(scope)}`;
        }
        return result + this.quasis[this.quasis.length - 1].cooked;
    }
    toString() {
        let result = "";
        for (let i = 0; i < this.expressions.length; i++) {
            result += `${this.quasis[i].raw}\$\{${this.expressions[i]}\}`;
        }
        return `\`${result + this.quasis[this.quasis.length - 1].raw}\``;
    }
}
