import NodeType from "../node-type.js";
const unaryFunctions = {
    "!": (expression, scope) => !expression.evaluate(scope),
    "+": (expression, scope) => +expression.evaluate(scope),
    "-": (expression, scope) => -expression.evaluate(scope),
    "typeof": (expression, scope) => typeof expression.evaluate(scope),
    "~": (expression, scope) => ~expression.evaluate(scope),
};
export default class UnaryExpression {
    _argument;
    get argument() {
        return this._argument;
    }
    /* c8 ignore next 4 */
    set argument(value) {
        this._argument = value;
    }
    operation;
    _operator;
    get operator() {
        return this._operator;
    }
    /* c8 ignore next 4 */
    set operator(value) {
        this._operator = value;
    }
    get type() {
        return NodeType.UnaryExpression;
    }
    constructor(argument, operator) {
        this._operator = operator;
        this._argument = argument;
        this.operation = unaryFunctions[this.operator];
    }
    clone() {
        return new UnaryExpression(this.argument.clone(), this.operator);
    }
    evaluate(scope) {
        return this.operation(this.argument, scope);
    }
    toString() {
        return `${this.operator}${this.operator == "typeof" ? " " : ""}${this.argument}`;
    }
}
