import type IExpression from "../interfaces/expression.js";
import NodeType from "../node-type.js";
import type { UpdateOperator } from "../types/operators.js";
import type Identifier from "./identifier.js";
import type MemberExpression from "./member-expression.js";
export default class UpdateExpression implements IExpression {
    private readonly operation;
    private _argument;
    private _operator;
    private _prefix;
    get argument(): Identifier | MemberExpression;
    set argument(value: Identifier | MemberExpression);
    get operator(): UpdateOperator;
    set operator(value: UpdateOperator);
    get prefix(): boolean;
    set prefix(value: boolean);
    get type(): NodeType;
    constructor(argument: Identifier | MemberExpression, operator: UpdateOperator, prefix: boolean);
    clone(): UpdateExpression;
    evaluate(scope: object): number;
    toString(): string;
}
