import type IExpression from "./interfaces/expression.js";
export default class Parser {
    private readonly scanner;
    private invalidInitialization;
    private lookahead;
    private constructor();
    static parse(source: string): IExpression;
    private createDupeChecker;
    private arguments;
    private arrayPattern;
    private arrayExpression;
    private assignmentExpression;
    private binaryExpression;
    private binaryPrecedence;
    private conditionalExpression;
    private pattern;
    private expect;
    private exponentiationExpression;
    private expression;
    private inheritGrammar;
    private isolateExpression;
    private isolateGrammar;
    private hasMixedCoalescingAndLogical;
    private groupExpression;
    private leftHandSideExpression;
    private objectPattern;
    private objectExpression;
    private objectPropertyExpression;
    private match;
    private matchKeyword;
    private nextToken;
    private nextRegexToken;
    private newPrimaryExpression;
    private parseExpression;
    private primaryExpression;
    private reinterpret;
    private reinterpretAssignmentExpression;
    private reinterpretArrayExpression;
    private reinterpretObjectExpression;
    private reinterpretProperty;
    private reinterpretSpreadElement;
    private regexExpression;
    private restElement;
    private spreadExpression;
    private syntaxError;
    private unaryExpression;
    private templateLiteralExpression;
    private updateExpression;
    private unexpectedTokenError;
}
