import NodeType from "../node-type.js";
import { PATTERN } from "../symbols.js";
import TypeGuard from "../type-guard.js";
export default class ArrayPattern {
    _elements;
    [PATTERN];
    get elements() {
        return this._elements;
    }
    /* c8 ignore next 4 */
    set elements(value) {
        this._elements = value;
    }
    get type() {
        return NodeType.ArrayPattern;
    }
    constructor(elements) {
        this._elements = elements;
    }
    clone() {
        return new ArrayPattern(this.elements.map(x => x?.clone() ?? null));
    }
    evaluate(scope, value) {
        const currentScope = {};
        let index = 0;
        for (const element of this.elements) {
            if (element) {
                if (TypeGuard.isRestElement(element)) {
                    Object.assign(currentScope, element.evaluate(scope, value.slice(index)));
                }
                else {
                    Object.assign(currentScope, element.evaluate(scope, value[index]));
                }
            }
            index++;
        }
        return currentScope;
    }
    toString() {
        return `[${this.elements.map(x => (x ?? "").toString()).join(", ")}]`;
    }
}
