import Messages from "../messages.js";
import NodeType from "../node-type.js";
import { PATTERN } from "../symbols.js";
import TypeGuard from "../type-guard.js";
export default class AssignmentPattern {
    _left;
    _right;
    [PATTERN];
    get left() {
        return this._left;
    }
    /* c8 ignore next 4 */
    set left(value) {
        this._left = value;
    }
    get right() {
        return this._right;
    }
    /* c8 ignore next 4 */
    set right(value) {
        this._right = value;
    }
    get type() {
        return NodeType.AssignmentPattern;
    }
    constructor(left, right) {
        this._left = left;
        this._right = right;
    }
    clone() {
        return new AssignmentPattern(this.left.clone(), this.right.clone());
    }
    evaluate(scope, value) {
        if (TypeGuard.isIdentifier(this.left)) {
            return { [this.left.name]: value ?? this.right.evaluate(scope) };
        }
        throw new Error(Messages.illegalPropertyInDeclarationContext);
    }
    toString() {
        return `${this.left} = ${this.right}`;
    }
}
