import NodeType from "../node-type.js";
import { PATTERN } from "../symbols.js";
import TypeGuard from "../type-guard.js";
export default class RestElement {
    _argument;
    [PATTERN];
    get argument() {
        return this._argument;
    }
    /* c8 ignore next 4 */
    set argument(value) {
        this._argument = value;
    }
    get type() {
        return NodeType.RestElement;
    }
    constructor(argument) {
        this._argument = argument;
    }
    clone() {
        return new RestElement(this.argument.clone());
    }
    evaluate(scope, value) {
        if (TypeGuard.isIdentifier(this.argument)) {
            return { [this.argument.name]: value };
        }
        return this.argument.evaluate(scope, value);
    }
    toString() {
        return `...${this.argument}`;
    }
}
