import type Token from "./types/token.js";
export default class Scanner {
    private readonly curlyStack;
    private readonly length;
    private lineNumber;
    private lineStart;
    private readonly _source;
    get source(): string;
    private _index;
    get index(): number;
    constructor(source: string);
    private advance;
    private eof;
    private isKeyword;
    private isBinary;
    private isImplicitOctalLiteral;
    private getIdentifier;
    private getComplexIdentifier;
    private hexValue;
    private octalToDecimal;
    private scanBinaryLiteral;
    private scanHexEscape;
    private scanHexLiteral;
    private scanIdentifier;
    private scanNumericLiteral;
    private scanOctalLiteral;
    private scanStringLiteral;
    private scanPunctuator;
    private scanTemplate;
    private scanUnicodeCodePointEscape;
    private setCursorAt;
    private throwUnexpectedToken;
    backtrack(steps: number): void;
    nextToken(): Token;
    scanRegex(): Token;
}
