import type AssignmentProperty from "./elements/assignment-property.js";
import type Property from "./elements/property.js";
import type SpreadElement from "./elements/spread-element.js";
import type TemplateElement from "./elements/template-element.js";
import type ArrayExpression from "./expressions/array-expression.js";
import type ArrowFunctionExpression from "./expressions/arrow-function-expression.js";
import type AssignmentExpression from "./expressions/assignment-expression.js";
import type BinaryExpression from "./expressions/binary-expression.js";
import type CallExpression from "./expressions/call-expression.js";
import type ChainExpression from "./expressions/chain-expression.js";
import type ConditionalExpression from "./expressions/conditional-expression.js";
import type Identifier from "./expressions/identifier.js";
import type Literal from "./expressions/literal.js";
import type LogicalExpression from "./expressions/logical-expression.js";
import type MemberExpression from "./expressions/member-expression.js";
import type NewExpression from "./expressions/new-expression.js";
import type ObjectExpression from "./expressions/object-expression.js";
import type ParenthesizedExpression from "./expressions/parenthesized-expression.js";
import type SequenceExpression from "./expressions/sequence-expression.js";
import type TaggedTemplateExpression from "./expressions/tagged-template-expression.js";
import type TemplateLiteral from "./expressions/template-literal.js";
import type ThisExpression from "./expressions/this-expression.js";
import type UnaryExpression from "./expressions/unary-expression.js";
import type UpdateExpression from "./expressions/update-expression.js";
import type INode from "./interfaces/node.js";
import type ArrayPattern from "./patterns/array-pattern.js";
import type AssignmentPattern from "./patterns/assignment-pattern.js";
import type ObjectPattern from "./patterns/object-pattern.js";
import type RestElement from "./patterns/rest-element.js";
export default class TypeGuard {
    static isArrayExpression(node: INode): node is ArrayExpression;
    static isArrayPattern(node: INode): node is ArrayPattern;
    static isArrowFunctionExpression(node: INode): node is ArrowFunctionExpression;
    static isAssignmentExpression(node: INode): node is AssignmentExpression;
    static isAssignmentProperty(node: INode): node is AssignmentProperty;
    static isAssignmentPattern(node: INode): node is AssignmentPattern;
    static isBinaryExpression(node: INode): node is BinaryExpression;
    static isCallExpression(node: INode): node is CallExpression;
    static isChainExpression(node: INode): node is ChainExpression;
    static isConditionalExpression(node: INode): node is ConditionalExpression;
    static isIdentifier(node: INode): node is Identifier;
    static isLiteral(node: INode): node is Literal;
    static isLogicalExpression(node: INode): node is LogicalExpression;
    static isMemberExpression(node: INode): node is MemberExpression;
    static isNewExpression(node: INode): node is NewExpression;
    static isObjectExpression(node: INode): node is ObjectExpression;
    static isObjectPattern(node: INode): node is ObjectPattern;
    static isParenthesizedExpression(node: INode): node is ParenthesizedExpression;
    static isProperty(node: INode): node is Property;
    static isRestElement(node: INode): node is RestElement;
    static isSequenceExpression(node: INode): node is SequenceExpression;
    static isSpreadElement(node: INode): node is SpreadElement;
    static isTaggedTemplateExpression(node: INode): node is TaggedTemplateExpression;
    static isTemplateLiteral(node: INode): node is TemplateLiteral;
    static isTemplateElement(node: INode): node is TemplateElement;
    static isThisExpression(node: INode): node is ThisExpression;
    static isUnaryExpression(node: INode): node is UnaryExpression;
    static isUpdateExpression(node: INode): node is UpdateExpression;
}
